## gringo 5.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

file(READ "libclingo/clingo.h" clingoh)
string(REGEX MATCH "#define CLINGO_VERSION \"([^\"]*)\"" clingov ${clingoh})

project(CLINGO VERSION "${CMAKE_MATCH_1}" LANGUAGES C CXX)
if (POLICY CMP0063)
    cmake_policy(SET CMP0063 NEW)
endif()
if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "No build type selected - using 'Release'")
    set(CMAKE_BUILD_TYPE "Release")
endif()

include(GNUInstallDirs)
include(CMakeDependentOption)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(clingo_functions)

# Enable folders in IDEs like Visual Studio
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

option(CLINGO_BUILD_WEB         "enable web target"             OFF)
option(CLINGO_BUILD_STATIC      "do not build shared libraries" OFF)
option(CLINGO_BUILD_WITH_PYTHON "enable python support"          ON)
option(CLINGO_BUILD_WITH_LUA    "enable lua support"             ON)
option(CLINGO_BUILD_TESTS       "build tests"                   OFF)
option(CLINGO_BUILD_EXAMPLES    "build examples"                OFF)
option(CLINGO_BUILD_APPS        "build applications"             ON)
option(CLINGO_MANAGE_RPATH      "set rpath if not installed into system directory" ON)

CMAKE_DEPENDENT_OPTION(CLINGO_REQUIRE_PYTHON   "fail if python support not found" OFF "CLINGO_BUILD_WITH_PYTHON" OFF)
CMAKE_DEPENDENT_OPTION(CLINGO_REQUIRE_LUA      "fail if lua support not found"    OFF "CLINGO_BUILD_WITH_LUA"    OFF)
CMAKE_DEPENDENT_OPTION(CLINGO_BUILD_SHARED     "build clingo library shared"      ON  "NOT CLINGO_BUILD_STATIC"  OFF)
CMAKE_DEPENDENT_OPTION(CLINGO_BUILD_PY_SHARED  "build pyclingo library shared"    OFF "NOT CLINGO_BUILD_STATIC"  OFF)
CMAKE_DEPENDENT_OPTION(CLINGO_BUILD_LUA_SHARED "build luaclingo library shared"   OFF "NOT CLINGO_BUILD_STATIC"  OFF)

option(PYCLINGO_USER_INSTALL "install the python module in the user's site directory" ON)
option(PYCLINGO_DYNAMIC_LOOKUP "do not link to python library and pass linker option `-undefined link_dynamic`" ${APPLE})
CMAKE_DEPENDENT_OPTION(PYCLINGO_USE_INSTALL_PREFIX "install the python module under the install prefix" OFF "NOT PYCLINGO_USER_INSTALL" OFF)

set(CLINGO_CLINGOPATH "" CACHE STRING "global search directories for clingo's include statement")
set(CLINGO_USE_LIB OFF CACHE BOOL "advanced option to build python and lua modules against an existing libclingo")
set(CLINGO_BUILD_REVISION "" CACHE STRING "revision string to add to version information")

mark_as_advanced(CLINGO_BUILD_WEB)
mark_as_advanced(CLINGO_BUILD_STATIC)
mark_as_advanced(CLINGO_BUILD_SHARED)
mark_as_advanced(CLINGO_BUILD_PY_SHARED)
mark_as_advanced(CLINGO_BUILD_LUA_SHARED)
mark_as_advanced(CLINGO_USE_LIB)
mark_as_advanced(CLINGO_BUILD_REVISION)

# workaround to set custom ar and ranlib
if (CLINGO_CMAKE_AR)
    set(CMAKE_AR "${CLINGO_CMAKE_AR}")
    set(CMAKE_CXX_ARCHIVE_CREATE "<CMAKE_AR> qc <TARGET> <LINK_FLAGS> <OBJECTS>")
    set(CMAKE_C_ARCHIVE_CREATE "<CMAKE_AR> qc <TARGET> <LINK_FLAGS> <OBJECTS>")
endif()
if (CLINGO_CMAKE_RANLIB)
    set(CMAKE_RANLIB "${CLINGO_CMAKE_RANLIB}")
    set(CMAKE_CXX_ARCHIVE_FINISH "<CMAKE_RANLIB> <TARGET>")
    set(CMAKE_C_ARCHIVE_FINISH "<CMAKE_RANLIB> <TARGET>")
endif()

if (CLINGO_MANAGE_RPATH)
    set(CMAKE_SKIP_BUILD_RPATH FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_FULL_LIBDIR}" isSystemDir)
    if ("${isSystemDir}" STREQUAL "-1")
        set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}")
    endif()
endif()

if (CLINGO_BUILD_WEB)
    unset(CMAKE_C_USE_RESPONSE_FILE_FOR_LIBRARIES)
    unset(CMAKE_CXX_USE_RESPONSE_FILE_FOR_LIBRARIES)
    unset(CMAKE_C_USE_RESPONSE_FILE_FOR_OBJECTS)
    unset(CMAKE_CXX_USE_RESPONSE_FILE_FOR_OBJECTS)
    unset(CMAKE_C_USE_RESPONSE_FILE_FOR_INCLUDES)
    unset(CMAKE_CXX_USE_RESPONSE_FILE_FOR_INCLUDES)
endif()

if (NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
endif()
if (NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
endif()
if (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
endif()
if (NOT CMAKE_IMPORT_LIBRARY_PREFIX)
    set(CMAKE_IMPORT_LIBRARY_PREFIX import_)
endif()

# NOTE: searching for the interpreter first increases the chance
#       that searching for the python libraries finds the matching libraries for the default python interpreter
#       python is also used to run the tests
find_package(PythonInterp)
add_library(Pyclingo::Pyclingo INTERFACE IMPORTED)
if (CLINGO_BUILD_WITH_PYTHON)
    if (CLINGO_REQUIRE_PYTHON)
        find_package(PythonLibs REQUIRED)
    else()
        find_package(PythonLibs)
    endif()
    if(PYTHONLIBS_FOUND)
        add_library(Python::Python INTERFACE IMPORTED)
        set_property(TARGET Python::Python PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${PYTHON_INCLUDE_DIRS}")
        if (PYCLINGO_DYNAMIC_LOOKUP)
            set_property(TARGET Pyclingo::Pyclingo PROPERTY INTERFACE_LINK_LIBRARIES "${PYTHON_LIBRARIES}")
        else()
            set_property(TARGET Python::Python PROPERTY INTERFACE_LINK_LIBRARIES "${PYTHON_LIBRARIES}")
        endif()
    endif()
endif()
if (CLINGO_BUILD_WITH_LUA)
    if (CLINGO_REQUIRE_LUA)
        find_package(Lua REQUIRED)
    else()
        find_package(Lua)
    endif()
    if(LUA_FOUND)
        add_library(Lua::Lua INTERFACE IMPORTED)
        set_property(TARGET Lua::Lua PROPERTY INTERFACE_LINK_LIBRARIES "${LUA_LIBRARIES}")
        set_property(TARGET Lua::Lua PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${LUA_INCLUDE_DIR}")
    endif()
endif()
find_package(BISON "2.5")
find_package(RE2C "0.13")

if (POLICY CMP0063 AND (CLINGO_BUILD_SHARED OR PYTHONLIBS_FOUND OR LUA_FOUND))
    set(CMAKE_CXX_VISIBILITY_PRESET hidden)
    set(CMAKE_C_VISIBILITY_PRESET hidden)
endif()

enable_testing()

# NOTE: assumes that submodule has been initialized
set(CLASP_BUILD_APP ${CLINGO_BUILD_APPS} CACHE BOOL "")
if (CLINGO_USE_LIB)
    set(clingo_library_targets)
    add_library(libclingo INTERFACE IMPORTED)
    set_property(TARGET libclingo PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${CLINGO_SOURCE_DIR}/libclingo")
    set_property(TARGET libclingo PROPERTY INTERFACE_LINK_LIBRARIES "clingo")
else()
    set(clingo_library_targets libclingo libgringo libpotassco libclasp libreify)
    add_subdirectory(clasp)
    add_subdirectory(libreify)
    add_subdirectory(libgringo)
    add_subdirectory(libclingo)
endif()
if (PYTHONLIBS_FOUND)
    add_subdirectory(libpyclingo)
    list(APPEND clingo_library_targets libpyclingo)
else()
    add_library(libpyclingo INTERFACE IMPORTED)
endif()
if (LUA_FOUND)
    add_subdirectory(libluaclingo)
    list(APPEND clingo_library_targets libluaclingo)
else()
    add_library(libluaclingo INTERFACE IMPORTED)
endif()
if (CLINGO_BUILD_APPS AND NOT CLINGO_USE_LIB)
    add_subdirectory(app/reify)
    add_subdirectory(app/gringo)
    add_subdirectory(app/clingo)
endif()
if (CLINGO_BUILD_EXAMPLES)
    add_subdirectory(examples/c)
    add_subdirectory(examples/cc)
endif()
if (NOT CLINGO_BUILD_STATIC AND PYTHONLIBS_FOUND)
    add_subdirectory(app/pyclingo)
endif()
if (NOT CLINGO_BUILD_STATIC AND LUA_FOUND)
    add_subdirectory(app/luaclingo)
endif()
if (CLINGO_BUILD_WEB)
    add_subdirectory(app/web)
endif()
if (NOT CLINGO_BUILD_STATIC AND (CLINGO_BUILD_SHARED OR PYTHONLIBS_FOUND OR LUA_FOUND))
    foreach(target ${clingo_library_targets})
        set_target_properties(${target} PROPERTIES POSITION_INDEPENDENT_CODE ON)
    endforeach()
endif()

=== libclingo/CMakeLists.txt ===
# [[[header: .
set(ide_header_group "Header Files")
set(header-group
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo.hh")
source_group("${ide_header_group}" FILES ${header-group})
set(header-group-clingo
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo/ast.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo/clingo_app.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo/clingocontrol.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo/control.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo/incmode.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo/script.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/clingo/scripts.hh")
source_group("${ide_header_group}\\clingo" FILES ${header-group-clingo})
set(header
    ${header-group}
    ${header-group-clingo})
# ]]]
# [[[source: src
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/src/ast.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/clingo_app.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/clingocontrol.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/control.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/gringo_app.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/incmode.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/scripts.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

list(APPEND header "${CLASP_SOURCE_DIR}/app/clasp_app.h")
list(APPEND source "${CLASP_SOURCE_DIR}/app/clasp_app.cpp")

if (CLINGO_BUILD_SHARED)
    set(clingo_lib_type SHARED)
else()
    set(clingo_lib_type STATIC)
endif()

add_library(libclingo ${clingo_lib_type} ${header} ${source})
target_link_libraries(libclingo PRIVATE libgringo libclasp)
target_include_directories(libclingo
    PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
    PRIVATE
    "$<BUILD_INTERFACE:${CLASP_SOURCE_DIR}/app>")
target_compile_definitions(libclingo PRIVATE CLINGO_BUILD_LIBRARY)
if (NOT CLINGO_BUILD_SHARED)
    target_compile_definitions(libclingo PUBLIC CLINGO_NO_VISIBILITY)
else()
    set_target_properties(libclingo PROPERTIES SOVERSION 2 VERSION 2.0)
    install(TARGETS libclingo
        EXPORT ClingoTargets
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
    install(FILES
        "${CMAKE_CURRENT_SOURCE_DIR}/clingo.hh"
        "${CMAKE_CURRENT_SOURCE_DIR}/clingo.h"
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
    install(EXPORT ClingoTargets
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Clingo)

    include(CMakePackageConfigHelpers)
    configure_package_config_file(
        ${PROJECT_SOURCE_DIR}/cmake/ClingoConfig.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/ClingoConfig.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Clingo)
    write_basic_package_version_file(
        ${CMAKE_CURRENT_BINARY_DIR}/ClingoConfigVersion.cmake
        COMPATIBILITY SameMajorVersion)
    install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/ClingoConfig.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/ClingoConfigVersion.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Clingo)
endif()
if (MSVC)
    target_compile_definitions(libclingo PRIVATE _SCL_SECURE_NO_WARNINGS)
endif()
if (CLINGO_BUILD_REVISION)
    target_compile_definitions(libclingo PRIVATE CLINGO_BUILD_REVISION=${CLINGO_BUILD_REVISION})
endif()
set_target_properties(libclingo PROPERTIES
    OUTPUT_NAME clingo
    FOLDER lib)

if (CLINGO_BUILD_TESTS)
    add_subdirectory(tests)
endif()

=== app/clingo/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

add_executable(clingo ${header} ${source})
target_link_libraries(clingo PRIVATE libclingo libpyclingo Pyclingo::Pyclingo libluaclingo)
set_target_properties(clingo PROPERTIES FOLDER exe)

install(TARGETS clingo RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

if (CLINGO_BUILD_TESTS)
    add_subdirectory(tests)
endif()

=== app/gringo/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

add_executable(gringo ${header} ${source})
target_link_libraries(gringo PRIVATE libpyclingo Pyclingo::Pyclingo libluaclingo libclingo)
set_target_properties(gringo PROPERTIES FOLDER exe)

install(TARGETS gringo RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== app/pyclingo/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

if (NOT PYCLINGO_INSTALL_DIR AND PYTHON_EXECUTABLE)
    if (PYCLINGO_USER_INSTALL)
        execute_process(COMMAND ${PYTHON_EXECUTABLE} -m site --user-site OUTPUT_VARIABLE PYCLINGO_INSTALL_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
    elseif(PYCLINGO_USE_INSTALL_PREFIX)
        execute_process(COMMAND ${PYTHON_EXECUTABLE} ${CLINGO_SOURCE_DIR}/cmake/python-site.py prefix "${CMAKE_INSTALL_PREFIX}" OUTPUT_VARIABLE PYCLINGO_INSTALL_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
    else()
        execute_process(COMMAND ${PYTHON_EXECUTABLE} ${CLINGO_SOURCE_DIR}/cmake/python-site.py prefix OUTPUT_VARIABLE PYCLINGO_INSTALL_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
    endif()
endif()

if (NOT PYCLINGO_SUFFIX)
    if (PYTHON_EXECUTABLE)
        execute_process(COMMAND ${PYTHON_EXECUTABLE} ${CLINGO_SOURCE_DIR}/cmake/python-site.py suffix OUTPUT_VARIABLE PYCLINGO_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
    else()
        if (CYGWIN)
            set(PYCLINGO_SUFFIX ".dll")
        elseif (UNIX)
            set(PYCLINGO_SUFFIX ".so")
        else()
            set(PYCLINGO_SUFFIX ".pyd")
        endif()
    endif()
endif()

add_library(pyclingo SHARED ${source})
if (PYCLINGO_DYNAMIC_LOOKUP)
    set_property(TARGET pyclingo PROPERTY LINK_FLAGS "-undefined dynamic_lookup")
endif()
target_link_libraries(pyclingo PRIVATE libpyclingo)
set_target_properties(pyclingo PROPERTIES
    FOLDER lib
    OUTPUT_NAME clingo
    SUFFIX ${PYCLINGO_SUFFIX}
    PREFIX "")
target_include_directories(pyclingo PRIVATE ${PYTHON_INCLUDE_DIRS})
if (CMAKE_RUNTIME_OUTPUT_DIRECTORY)
    set_target_properties(pyclingo PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/python)
endif()
if (CMAKE_LIBRARY_OUTPUT_DIRECTORY)
    set_target_properties(pyclingo PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/python)
endif()
if (CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
    set_target_properties(pyclingo PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}/python)
endif()

if (PYCLINGO_INSTALL_DIR)
    install(TARGETS pyclingo
        RUNTIME DESTINATION ${PYCLINGO_INSTALL_DIR}
        LIBRARY DESTINATION ${PYCLINGO_INSTALL_DIR})
endif()

=== app/web/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

add_executable(web ${header} ${source})
target_link_libraries(web libclingo libclasp libluaclingo libpyclingo Pyclingo::Pyclingo)
set_target_properties(web PROPERTIES FOLDER exe)
target_include_directories(web PRIVATE
    "$<BUILD_INTERFACE:${CLINGO_SOURCE_DIR}/libgringo>"
    "$<BUILD_INTERFACE:${CLASP_SOURCE_DIR}/app>")

set_target_properties(web PROPERTIES LINK_FLAGS
    "-s EXPORTED_FUNCTIONS='[\"_run\"]' -s EXTRA_EXPORTED_RUNTIME_METHODS='[\"ccall\"]'")
set_target_properties(web PROPERTIES OUTPUT_NAME "clingo")

=== debian/changelog ===
gringo (5.3.0-10) unstable; urgency=medium

  * Fix FTBFS on buster.
  * debian/control: add Build-Depends on g++-8 >= 8.2.0-21
  * debian/symbols: add alpha and x32 symbols

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 02 Mar 2019 08:49:10 +0100

gringo (5.3.0-9) unstable; urgency=medium

  * Upload to unstable.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 01 Mar 2019 06:27:37 +0100

gringo (5.3.0-8) experimental; urgency=medium

  * debian/symbols: fix symbols

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 28 Feb 2019 05:25:47 +0100

gringo (5.3.0-7) experimental; urgency=medium

  * Bug fix: "new symbols", thanks to Sjoerd Simons (Closes: #923228).
  * debian/control: bump Standards-Version to 4.3.0
  * debian/symbols: fix FTBFS on powerpcspe

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 27 Feb 2019 05:24:41 +0100

gringo (5.3.0-6) unstable; urgency=medium

  * debian/symbols: fix symbols for g++-8 >= 8.2.0-10
  * Upload to unstable.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 14 Dec 2018 08:09:08 +0100

gringo (5.3.0-5) experimental; urgency=medium

  * Bug fix: "gringo FTBFS: symbol differences", thanks to Adrian Bunk
    (Closes: #916266).
  * debian/symbols: fix FTBFS for g++-8 >= 8.2.0-10
  * debian/control: Build-Depends on g++-8 >= 8.2.0-10

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 13 Dec 2018 08:22:24 +0100

gringo (5.3.0-4) unstable; urgency=medium

  * debian/tests/gringo{0,1,3,4}: fix integer atom mappings
  * NEWS.Debian: fix link to aspif description

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 22 Nov 2018 07:26:25 +0100

gringo (5.3.0-3) unstable; urgency=medium

  * debian/upstream/metadata: add DEP-12 upstream metadata
  * debian/symbols: fix symbols for version 5.3.0 of libclingo.so.2
  * Upload to unstable.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 21 Nov 2018 04:54:38 +0100

gringo (5.3.0-2) experimental; urgency=medium

  * debian/symbols: fix symbols for version 5.3.0 of libclingo.so.2

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 15 Nov 2018 07:30:26 +0100

gringo (5.3.0-1) experimental; urgency=medium

  * New upstream version 5.3.0
  * drop upstream applied gringo-makefile.patch
  * refresh gringo-python37-async.patch with fcef335 from upstream
  * install libclingo.so.2.0
  * debian/symbols: update to libclingo.so.2.0

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 11 Nov 2018 08:56:35 +0100

gringo (5.2.3-5) unstable; urgency=medium

  * debian/symbols: batchpatch alpha, mips, mips64el symbols for g++-8

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 08 Nov 2018 04:35:55 +0100

gringo (5.2.3-4) unstable; urgency=medium

  * Bug fix: "Please update symbols for riscv64", thanks to Manuel
    A. Fernandez Montecelo (Closes: #912269).
  * debian/symbols: batchpatch symbols for g++-8
  * Upload to unstable.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 07 Nov 2018 04:07:00 +0100

gringo (5.2.3-3) experimental; urgency=medium

  * debian/control: bump Standards-Version to 4.2.1
  * Bug fix: "gringo build-depends on legacy compiler g++-7", thanks to
    Matthias Klose (Closes: #912582).
    - debian/control: Build-Depends on g++-8
  * debian/symbols: update amd64 symbols for g++-8
  * Bug fix: "gringo ftbfs with Python 3.7", thanks to Matthias Klose
    (Closes: #912552).
    - debian/control: Build-Depends on python3.7
    - gringo-python37-async.patch: rename async keyword to async_

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 04 Nov 2018 08:34:30 +0100

=== debian/control ===
Source: gringo
Section: interpreters
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
Build-Depends: debhelper (>= 11),
 dpkg-dev (>= 1.16.1~),
 pkg-kde-tools,
 g++-8 (>= 8.2.0-21),
 cmake (>= 3.1.0),
 re2c,
 bison,
 liblua5.3-dev,
 python3.7,
 libpython3.7-dev,
 python3.7-distutils
Standards-Version: 4.3.0
Vcs-Git: https://salsa.debian.org/science-team/gringo.git
Vcs-Browser: https://salsa.debian.org/science-team/gringo
Homepage: https://www.potassco.org/clingo/

Package: gringo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: clasp
Replaces: clingo, iclingo
Conflicts: clingo, iclingo
Breaks:
 aspcud (<= 1.9.0-2),
 clasp (<< 3.2.1-1)
Description: grounding tools for (disjunctive) logic programs
 Current answer set solvers work on variable-free programs. Hence, a
 grounder is needed that, given an input program with first-order
 variables, computes an equivalent ground (variable-free) program.
 .
 This package contains the following tools:
 .
  - gringo: a grounder that, given an input program with first-order
    variables, computes an equivalent ground (variable-free) program in
    aspif format. Its output can be processed further with answer set
    solver clasp. Starting with gringo series 5, its output is no longer
    directly compatible with solvers like smodels or cmodels reading
    smodels format. Use lpconvert for translating aspif format to
    smodels format.
  - clingo: combines both gringo and clasp into a monolithic system.
    This way it offers more control over the grounding and solving
    process than gringo and clasp can offer individually: multi-shot
    solving.
  - lpconvert: converter between gringo's aspif and smodels format.
  - reify: small utility that reifies logic programs given in aspif
    format. It produces a set of facts, which can be processed further
    with gringo.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# gringo requires c++11 threads with 64bit __atomic_exchange, we need to
# link with libatomic on armel, powerpc, powerpcspe, m68k, mips, mipsel, and
# sh4, see also
# https://gcc.gnu.org/wiki/Atomic
# https://gcc.gnu.org/wiki/Atomic/GCCMM/LIbrary
arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep -x "(armel|powerpc|powerpcspe|m68k|mips|mipsel|sh4)")

# use custom hardening config flags for compiling clasp
CONFIG=hardening
CONFIGPARMS = -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr -LAH -DCMAKE_SKIP_RPATH=YES -DCLINGO_MANAGE_RPATH=OFF -DLIB_POTASSCO_BUILD_APP=ON -DLIB_POTASSCO_BUILD_TESTS=ON -DCLASP_BUILD_APP=OFF -DCLASP_BUILD_TESTS=OFF -DCLASP_BUILD_EXAMPLES=OFF -DCLINGO_BUILD_EXAMPLES=ON -DCLINGO_BUILD_TESTS=ON -DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/python3.7
TOPBUILDDIR = build/$(CONFIG)_mt
ROOTDIR = $(shell pwd)

#
# export CXXFLAGS and LDFLAGS for cmake
#
# add -O3 and NDEBUG and enable all hardening flags
# link with libatomic on architectures without built-in atomic
#
DEB_CXXFLAGS_MAINT_APPEND = -O3 -DNDEBUG
DEB_LDFLAGS_MAINT_APPEND =
ifeq ($(if $(arch),atomic), atomic)
	DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

#
# export CPPFLAGS, CXXFLAGS, and LDFLAGS for scons
#
# default to -O3 -Wall -DNDEBUG and enable all hardening flags
#
DEB_CXXFLAGS_MAINT_APPEND = -O3 -Wall
DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG
DEB_LDFLAGS_MAINT_APPEND =
ifeq ($(if $(arch),atomic), atomic)
	DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# force g++-8
export CXX = g++-8
export CC = gcc-8
# inject CPPFLAGS to CXXFLAGS
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@ --with pkgkde_symbolshelper

# configure with cmake
override_dh_auto_configure:
	dh_auto_configure --builddirectory=$(TOPBUILDDIR) -- $(CONFIGPARMS)

# build binaries in $(TOPBUILDDIR)
override_dh_auto_build:
	dh_auto_build --builddirectory=$(TOPBUILDDIR)

override_dh_auto_clean:
	dh_auto_clean --builddirectory=$(TOPBUILDDIR)

# run and output test results
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --builddirectory=$(TOPBUILDDIR) -- -e LD_LIBRARY_PATH="$(ROOTDIR)/$(TOPBUILDDIR)/bin:$(LD_LIBRARY_PATH)" &&\
		{ EXIT_CODE=$$? ; echo "Exit $$EXIT_CODE" ; test -d $(TOPBUILDDIR)/Testing/Temporary && tail -n +1 -v -- $(TOPBUILDDIR)/Testing/Temporary/* ; exit $$EXIT_CODE ; } ||\
		{ EXIT_CODE=$$? ; echo "Exit $$EXIT_CODE" ; test -d $(TOPBUILDDIR)/Testing/Temporary && tail -n +1 -v -- $(TOPBUILDDIR)/Testing/Temporary/* ; exit $$EXIT_CODE ; }
endif

# install CHANGES.md as changelog
override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

override_dh_shlibdeps:
	dh_shlibdeps -l$(shell pwd)/$(TOPBUILDDIR)/bin

## gringo 5.4.0

=== libluaclingo/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/luaclingo.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/luaclingo.h")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

if (CLINGO_BUILD_LUA_SHARED)
    set(luaclingo_lib_type SHARED)
else()
    set(luaclingo_lib_type STATIC)
endif()

add_library(libluaclingo ${luaclingo_lib_type} ${source})
target_link_libraries(libluaclingo PUBLIC libclingo PRIVATE Lua::Lua)
target_include_directories(libluaclingo PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>")
target_compile_definitions(libluaclingo PRIVATE LUACLINGO_BUILD_LIBRARY PUBLIC CLINGO_WITH_LUA)
set_target_properties(libluaclingo PROPERTIES
    OUTPUT_NAME luaclingo
    FOLDER lib)
if (NOT CLINGO_BUILD_LUA_SHARED)
    target_compile_definitions(libluaclingo PUBLIC LUACLINGO_NO_VISIBILITY)
else()
    set_target_properties(libluaclingo PROPERTIES SOVERSION 1 VERSION 1.0)
    install(TARGETS libluaclingo
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

=== libpyclingo/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/pyclingo.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/pyclingo.h")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

if (CLINGO_BUILD_PY_SHARED)
    set(pyclingo_lib_type SHARED)
else()
    set(pyclingo_lib_type STATIC)
endif()

# for embedding
add_library(libpyclingo ${pyclingo_lib_type} ${source})
target_link_libraries(libpyclingo PUBLIC libclingo PRIVATE Python::Python)
target_include_directories(libpyclingo PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>")
target_compile_definitions(libpyclingo PRIVATE PYCLINGO_BUILD_LIBRARY PUBLIC CLINGO_WITH_PYTHON)
if (NOT CLINGO_BUILD_PY_SHARED)
    target_compile_definitions(libpyclingo PUBLIC PYCLINGO_NO_VISIBILITY)
else()
    set_target_properties(libpyclingo PROPERTIES SOVERSION 1 VERSION 1.0)
    install(TARGETS libpyclingo
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()
set_target_properties(libpyclingo PROPERTIES
    OUTPUT_NAME pyclingo
    FOLDER lib)

# for module
add_library(libpyclingom STATIC ${source})
target_link_libraries(libpyclingom PUBLIC libclingo Python::Module)
target_include_directories(libpyclingom PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>")
target_compile_definitions(libpyclingom PRIVATE PYCLINGO_BUILD_LIBRARY PUBLIC CLINGO_WITH_PYTHON)
target_compile_definitions(libpyclingom PUBLIC PYCLINGO_NO_VISIBILITY)
set_target_properties(libpyclingom PROPERTIES
    OUTPUT_NAME pyclingom
    FOLDER lib)

=== app/pyclingo/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

if (NOT PYCLINGO_INSTALL_DIR AND Python_EXECUTABLE)
    if (PYCLINGO_USER_INSTALL)
        execute_process(COMMAND ${Python_EXECUTABLE} -m site --user-site OUTPUT_VARIABLE PYCLINGO_INSTALL_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
    elseif(PYCLINGO_USE_INSTALL_PREFIX)
        execute_process(COMMAND ${Python_EXECUTABLE} ${CLINGO_SOURCE_DIR}/cmake/python-site.py prefix "${CMAKE_INSTALL_PREFIX}" OUTPUT_VARIABLE PYCLINGO_INSTALL_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
    else()
        execute_process(COMMAND ${Python_EXECUTABLE} ${CLINGO_SOURCE_DIR}/cmake/python-site.py prefix OUTPUT_VARIABLE PYCLINGO_INSTALL_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
    endif()
endif()

if (NOT PYCLINGO_SUFFIX)
    if (Python_EXECUTABLE)
        execute_process(COMMAND ${Python_EXECUTABLE} ${CLINGO_SOURCE_DIR}/cmake/python-site.py suffix OUTPUT_VARIABLE PYCLINGO_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
    else()
        if (CYGWIN)
            set(PYCLINGO_SUFFIX ".dll")
        elseif (UNIX)
            set(PYCLINGO_SUFFIX ".so")
        else()
            set(PYCLINGO_SUFFIX ".pyd")
        endif()
    endif()
endif()

add_library(pyclingo MODULE ${source})
if (PYCLINGO_DYNAMIC_LOOKUP)
    set_property(TARGET pyclingo PROPERTY LINK_FLAGS "-undefined dynamic_lookup")
endif()
target_link_libraries(pyclingo PRIVATE libpyclingom)
set_target_properties(pyclingo PROPERTIES
    FOLDER lib
    OUTPUT_NAME clingo
    SUFFIX ${PYCLINGO_SUFFIX}
    PREFIX "")
if (CMAKE_RUNTIME_OUTPUT_DIRECTORY)
    set_target_properties(pyclingo PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/python)
endif()
if (CMAKE_LIBRARY_OUTPUT_DIRECTORY)
    set_target_properties(pyclingo PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/python)
endif()
if (CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
    set_target_properties(pyclingo PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}/python)
endif()

if (PYCLINGO_INSTALL_DIR)
    install(TARGETS pyclingo
        RUNTIME DESTINATION ${PYCLINGO_INSTALL_DIR}
        LIBRARY DESTINATION ${PYCLINGO_INSTALL_DIR})
endif()

=== app/reify/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source
    ${source-group})
# ]]]

add_executable(reify ${header} ${source})
target_link_libraries(reify PRIVATE libreify libpotassco)
target_include_directories(reify PRIVATE
    "$<BUILD_INTERFACE:${CLINGO_SOURCE_DIR}/libclingo>")
set_target_properties(reify PROPERTIES FOLDER exe)
if (CLINGO_BUILD_REVISION)
    target_compile_definitions(reify PRIVATE CLINGO_BUILD_REVISION=${CLINGO_BUILD_REVISION})
endif()

install(TARGETS reify RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== app/web/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 # ]]]
 
 add_executable(web ${header} ${source})
-target_link_libraries(web libclingo libclasp libluaclingo libpyclingo Pyclingo::Pyclingo)
+target_link_libraries(web libclingo libclasp libluaclingo libpyclingo)
 set_target_properties(web PROPERTIES FOLDER exe)
 target_include_directories(web PRIVATE
     "$<BUILD_INTERFACE:${CLINGO_SOURCE_DIR}/libgringo>"

=== clasp/app/CMakeLists.txt ===
set(files
	clasp_app.cpp
	clasp_app.h
	main.cpp)
add_executable(clasp ${files})
set_target_properties(clasp PROPERTIES FOLDER exe)
if (NOT CMAKE_INSTALL_BINDIR)
	message(STATUS "BINDIR not set - using bin")
	set(CMAKE_INSTALL_BINDIR "bin")
endif()
if (CLASP_BUILD_STATIC AND UNIX AND NOT APPLE)
	if (CLASP_BUILD_WITH_THREADS)
		string(CONCAT refs "-Wl,-u,pthread_cancel,-u,pthread_cond_broadcast,"
		                   "-u,pthread_cond_destroy,-u,pthread_cond_signal,"
		                   "-u,pthread_cond_timedwait,-u,pthread_cond_wait,"
		                   "-u,pthread_create,-u,pthread_detach,-u,pthread_join,"
		                   "-u,pthread_equal")
		target_link_libraries(clasp ${refs})
	endif()
	target_link_libraries(clasp "-static")
endif()
target_link_libraries(clasp libclasp)

install(TARGETS clasp EXPORT clasp DESTINATION ${CMAKE_INSTALL_BINDIR})

=== clasp/tests/CMakeLists.txt ===
enable_testing()
file(GLOB src    *.cpp)
file(GLOB header *.h)
add_executable(test_clasp ${header} ${src})
target_link_libraries(test_clasp libclasp)
set_target_properties(test_clasp PROPERTIES FOLDER test)
add_test(NAME test_clasp COMMAND test_clasp)

=== examples/c/CMakeLists.txt ===
set(CMAKE_C_STANDARD 11)

add_executable(model "${CMAKE_CURRENT_SOURCE_DIR}/model.c")
target_link_libraries(model PRIVATE libclingo)
set_target_properties(model PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(version "${CMAKE_CURRENT_SOURCE_DIR}/version.c")
target_link_libraries(version PRIVATE libclingo)
set_target_properties(version PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(backend "${CMAKE_CURRENT_SOURCE_DIR}/backend.c")
target_link_libraries(backend PRIVATE libclingo)
set_target_properties(backend PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(control "${CMAKE_CURRENT_SOURCE_DIR}/control.c")
target_link_libraries(control PRIVATE libclingo)
set_target_properties(control PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(propagator "${CMAKE_CURRENT_SOURCE_DIR}/propagator.c")
target_link_libraries(propagator PRIVATE libclingo)
set_target_properties(propagator PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(symbolic-atoms "${CMAKE_CURRENT_SOURCE_DIR}/symbolic-atoms.c")
target_link_libraries(symbolic-atoms PRIVATE libclingo)
set_target_properties(symbolic-atoms PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(configuration "${CMAKE_CURRENT_SOURCE_DIR}/configuration.c")
target_link_libraries(configuration PRIVATE libclingo)
set_target_properties(configuration PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(statistics "${CMAKE_CURRENT_SOURCE_DIR}/statistics.c")
target_link_libraries(statistics PRIVATE libclingo)
set_target_properties(statistics PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(symbol "${CMAKE_CURRENT_SOURCE_DIR}/symbol.c")
target_link_libraries(symbol PRIVATE libclingo)
set_target_properties(symbol PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(ast "${CMAKE_CURRENT_SOURCE_DIR}/ast.c")
target_link_libraries(ast PRIVATE libclingo)
set_target_properties(ast PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(solve-async "${CMAKE_CURRENT_SOURCE_DIR}/solve-async.c")
target_link_libraries(solve-async PRIVATE libclingo)
set_target_properties(solve-async PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(theory-atoms "${CMAKE_CURRENT_SOURCE_DIR}/theory-atoms.c")
target_link_libraries(theory-atoms PRIVATE libclingo)
set_target_properties(theory-atoms PROPERTIES FOLDER "exe/clingo-c-examples")

add_executable(application "${CMAKE_CURRENT_SOURCE_DIR}/application.c")
target_link_libraries(application PRIVATE libclingo)
set_target_properties(application PROPERTIES FOLDER "exe/application")

=== libgringo/tests/CMakeLists.txt ===
# [[[source: .
set(ide_source_group "Source Files")
set(source-group
    "${CMAKE_CURRENT_SOURCE_DIR}/catch.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/graph.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/intervals.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/python.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/safetycheck.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/symbol.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/term.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/term_helper.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/tests.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/unique_vec.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/utility.cc")
source_group("${ide_source_group}" FILES ${source-group})
set(source-group-ground
    "${CMAKE_CURRENT_SOURCE_DIR}/ground/dependency.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/ground/grounder_helper.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/ground/instantiation.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/ground/literal.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/ground/program.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/ground/theory.cc")
source_group("${ide_source_group}\\ground" FILES ${source-group-ground})
set(source-group-input
    "${CMAKE_CURRENT_SOURCE_DIR}/input/aggregate.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/input/aggregate_helper.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/input/lit_helper.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/input/literal.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/input/nongroundgrammar.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/input/nongroundlexer.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/input/parse_term.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/input/program.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/input/programbuilder.cc")
source_group("${ide_source_group}\\input" FILES ${source-group-input})
set(source-group-output
    "${CMAKE_CURRENT_SOURCE_DIR}/output/aspcomp13.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/output/incremental.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/output/lparse.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/output/solver_helper.hh"
    "${CMAKE_CURRENT_SOURCE_DIR}/output/theory.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/output/warnings.cc")
source_group("${ide_source_group}\\output" FILES ${source-group-output})
set(source
    ${source-group}
    ${source-group-ground}
    ${source-group-input}
    ${source-group-output})
# ]]]

add_executable(test_gringo ${source})
target_link_libraries(test_gringo PRIVATE libgringo libclasp)
target_include_directories(test_gringo PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)
if(MSVC)
    target_compile_definitions(test_gringo PRIVATE _SCL_SECURE_NO_WARNINGS)
endif()
set_target_properties(test_gringo PROPERTIES FOLDER test)

add_test(NAME test_gringo COMMAND test_gringo)

=== app/clingo/tests/CMakeLists.txt ===
enable_testing()

if (Python_EXECUTABLE)
    if (CLASP_BUILD_WITH_THREADS)
        set(solver-options "-t8")
    endif()
    add_test(NAME test_clingo_app COMMAND ${Python_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/run.py" -c $<TARGET_FILE:clingo> run -- ${solver-options})
endif()

=== debian/changelog ===
gringo (5.4.0-2ubuntu1) groovy; urgency=medium

  * Mark two more symbols as optional when building with -march=z13 on s390x.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 18 Jun 2020 13:36:08 +0200

gringo (5.4.0-2) unstable; urgency=medium

  * Upload to unstable
  * debian/symbols: fix symbols for missing architectures

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 03 Apr 2020 06:56:49 -0400

gringo (5.4.0-1) experimental; urgency=medium

  * New upstream version 5.4.0
  * install libclingo.so.3.0 instead of libclingo.so.2.0
  * generate symbols for libclingo.so.3
  * refresh gringo-python3-utf8.patch, python3.8-compat.patch, and
    link-libatomic-check.patch
  * drop gringo-python37-async.patch, already applied upstream
  * add highlight.js 9.12.0 to missing-sources

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 30 Mar 2020 06:25:20 -0400

gringo (5.3.0-13) unstable; urgency=medium

  * Upload to unstable
  * debian/symbols: fix symbols for g++-9 >= 9.2.0 on armel and powerpc

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 11 Mar 2020 20:57:01 -0400

gringo (5.3.0-12) experimental; urgency=medium

  * debian/symbols: fix symbols for g++-9 >= 9.2.0
  * debian/{rules,install}: drop libatomic hacks, stop confusing build
    target with build directory
  * debian/patches: refresh python3.8-compat and gringo-python37-async
  * link-libatomic-check.patch: add libatomic checks to CMakeLists.txt

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 11 Mar 2020 07:31:40 -0400

gringo (5.3.0-11) experimental; urgency=medium

  * add support for python3.8, thanks to Steve Langasek
  * compile with gcc-9 and g++-9
  * debian/control: bump Standards-Version to 4.5.0 (no changes required)
  * renamed debian/{NEWS,TODO}.Debian to debian/{NEWS,TODO}
    Lintian tag incorrect-packaging-filename
  * setup debhelper-compat 12.
    Lintian tag package-uses-old-debhelper-compat-version
  * debian/control: set Rules-Requires-Root to no
  * debian/symbols: fix symbols for g++-9 >= 9.2.0
  * Bug fix: "gringo needs a new upstream, and fixes for python3.8",
    thanks to Matthias Klose (Closes: #951842).
  * Bug fix: "gringo ftbfs with Python 3.8", thanks to Matthias Klose
    (Closes: #951707).
  * Bug fix: "non-standard gcc/g++ used for build (gcc-8)", thanks to
    Matthias Klose (Closes: #944178).

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 09 Mar 2020 13:31:25 +0100

=== debian/control ===
--- 
+++ 
@@ -4,17 +4,19 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
 Build-Depends: debhelper (>= 11),
+ debhelper-compat (= 12),
  dpkg-dev (>= 1.16.1~),
  pkg-kde-tools,
- g++-8 (>= 8.2.0-21),
+ g++-9 (>= 9.2.1),
  cmake (>= 3.1.0),
  re2c,
  bison,
  liblua5.3-dev,
- python3.7,
- libpython3.7-dev,
- python3.7-distutils
-Standards-Version: 4.3.0
+ python3 (>= 3.8.2),
+ libpython3-dev (>= 3.8.2),
+ python3-distutils (>= 3.8.2)
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/science-team/gringo.git
 Vcs-Browser: https://salsa.debian.org/science-team/gringo
 Homepage: https://www.potassco.org/clingo/

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# use custom hardening config flags for compiling clasp
CONFIG=hardening
CONFIGPARMS = -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr -LAH -DCMAKE_SKIP_RPATH=YES -DCLINGO_MANAGE_RPATH=OFF -DLIB_POTASSCO_BUILD_APP=ON -DLIB_POTASSCO_BUILD_TESTS=ON -DCLASP_BUILD_APP=OFF -DCLASP_BUILD_TESTS=OFF -DCLASP_BUILD_EXAMPLES=OFF -DCLINGO_BUILD_EXAMPLES=ON -DCLINGO_BUILD_TESTS=ON -DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/python3
TOPBUILDDIR = build.dir/$(CONFIG)_mt
ROOTDIR = $(shell pwd)

#
# export CXXFLAGS and LDFLAGS for cmake
#
# default to -O3 -Wall -DNDEBUG and enable all hardening flags
#
DEB_CXXFLAGS_MAINT_APPEND = -O3 -Wall
DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG
DEB_LDFLAGS_MAINT_APPEND =

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# force g++-9
export CXX = g++-9
export CC = gcc-9
# inject CPPFLAGS to CXXFLAGS
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@ --with pkgkde_symbolshelper

# configure with cmake
override_dh_auto_configure:
	dh_auto_configure --builddirectory=$(TOPBUILDDIR) -- $(CONFIGPARMS)

# build binaries in $(TOPBUILDDIR)
override_dh_auto_build:
	dh_auto_build --builddirectory=$(TOPBUILDDIR)

override_dh_auto_clean:
	dh_auto_clean --builddirectory=$(TOPBUILDDIR)

# run and output test results
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --builddirectory=$(TOPBUILDDIR) -- -e LD_LIBRARY_PATH="$(ROOTDIR)/$(TOPBUILDDIR)/bin:$(LD_LIBRARY_PATH)" &&\
		{ EXIT_CODE=$$? ; echo "Exit $$EXIT_CODE" ; test -d $(TOPBUILDDIR)/Testing/Temporary && tail -n +1 -v -- $(TOPBUILDDIR)/Testing/Temporary/* ; exit $$EXIT_CODE ; } ||\
		{ EXIT_CODE=$$? ; echo "Exit $$EXIT_CODE" ; test -d $(TOPBUILDDIR)/Testing/Temporary && tail -n +1 -v -- $(TOPBUILDDIR)/Testing/Temporary/* ; exit $$EXIT_CODE ; }
endif

# install CHANGES.md as changelog
override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

override_dh_shlibdeps:
	dh_shlibdeps -l$(shell pwd)/$(TOPBUILDDIR)/bin
